DEFINT A-Z

' $INCLUDE: 'EDSTR.INC'
' $INCLUDE: 'PARM.INC'
' $INCLUDE: 'TRUEFALS.INC'
' $INCLUDE: 'VALIDNAM.INC'

DECLARE FUNCTION Ask4File$ (default$, msg$(), parm())
DECLARE FUNCTION Ask4File2$ (default$, msg$, parm())

'External functions:

DECLARE FUNCTION EditBox$ (msg$(), orig$, parm())
DECLARE SUB InfoBox2 (msg$, parm())
DECLARE FUNCTION YesNo (msg$(), y$, n$, parm())

FUNCTION Ask4File$ (default$, msg$(), parm())
'****************************************************************************
'Asks the user to enter a filename in a pop-up box.  The default$ argument
' can contain a suggested filename or be a null string.  The msg$() array
' holds the prompt text that appears in the box.  The function will return
' the entered filename or CHR$(27) if the user ESCapes.
'
'    parm(1) = top  0=Center
'    parm(2) = left  0=Center
'    parm(3) = box border type 1-4.  See SUB Panes() for boxtypes.
'    parm(4) = message justification  <0=Left  0=Center  >0=Right
'    parm(5) = maximum length of filename   Suggested: 40-65
'    parm(6) = initial insert/overwrite mode (Use SETCURS.INC constants)
'    parm(7) = input/output mode  0=Output  Non-zero=Input
'
'parm(7) is specified so the messages can be tailored to the activity - If
' selecting a file for input, the file would obviously need to exist.  If
' the file is to be used for output, the user must be prompted to see if they
' want to overwrite an existing file.
'
'****************************************************************************

REDIM temp(1 TO MAXPARM)                'Make a duplicate parm array
FOR x = MINPARM TO MAXPARM
     temp(x) = parm(x)
NEXT x
FOR x = 1 TO 4                          'These parameters are the same in
     temp(x) = parm(x)                  'all the functions called from here.
NEXT x

f$ = UCASE$(default$)

DO
     temp(5) = parm(5)
     temp(6) = parm(6)
     temp(7) = 1
     temp(8) = EDUPPER
     f$ = EditBox$(msg$(), f$, temp())
    
     IF f$ = CHR$(27) THEN EXIT DO                          'ESC?

     temp(5) = 0                                            'For InfoBox2()
     temp(6) = 0

     SELECT CASE ValidName(f$)
          CASE VNEXISTS
               IF parm(7) THEN                              'Input
                    EXIT DO
               ELSE                                         'Output
                    REDIM m$(1 TO 2)
                    m$(1) = " " + f$ + " already exists. "
                    m$(2) = "Overwrite?"
                    temp(5) = FALSE
                    temp(6) = TRUE
                    x = YesNo(m$(), "", "", temp())
                    ERASE m$
                    IF x THEN EXIT DO
               END IF
          CASE VNVALID
               IF parm(7) THEN                              'Input    
                    InfoBox2 " File not found. ", temp()
               ELSE                                         'Output
                    EXIT DO
               END IF
          CASE VNDRIVE
               InfoBox2 " Drive not ready. ", temp()
          CASE VNPATH
               InfoBox2 " Invalid path. ", temp()
          CASE VNFILENAME
               InfoBox2 " Invalid filename. ", temp()
     END SELECT
LOOP

ERASE temp
Ask4File$ = f$

END FUNCTION

FUNCTION Ask4File2$ (default$, msg$, parm())
'****************************************************************************
'Exactly like Ask4File$(), but a single message string is passed instead of
' an array.  See Ask4File$() for parm() settings.
'****************************************************************************

REDIM temp$(1 TO 1)
temp$(1) = msg$

Ask4File2$ = Ask4File$(default$, temp$(), parm())

ERASE temp$

END FUNCTION

