DEFINT A-Z

' $INCLUDE: 'TRUEFALS.INC'

DECLARE FUNCTION DiskReady (d$)


'Error handling:  (Must be compiled with the /X switch)

DIM SHARED diskcode

DiskErr:
     diskcode = ERR
     RESUME NEXT


FUNCTION DiskReady (d$) STATIC
'****************************************************************************
'DiskReady() determines if a diskette drive has a disk in it and is ready for
' action.  Pass the letter of the drive you wish to test.  A trailing colon
' will be ignored (Only the first character is used).  This makes it easy to
' pass the information returned from a call to FileParts$(f$,"D").
'
'Note:  If the system has only 1 diskette drive, and the other is specified,
' the DOS message "Insert a disk in drive B:" will appear on the screen in an
' unspecified location.  This function is not perfect, but can be effective
' if used with care.
'
'See also: FileParts$(), Dir$()
'
'****************************************************************************

'DOS has a "device" called NUL in every directory on every drive.  We will
'try to access this as a file in the root directory of the diskette we want
'to test.  If successful, it means there is a disk inserted in the specified
'drive.

x$ = LEFT$(d$, 1) + ":\NUL"

DiskReady = TRUE
diskcode = 0

fh = FREEFILE
ON ERROR GOTO DiskErr
OPEN x$ FOR INPUT AS #fh
ON ERROR GOTO 0
CLOSE #fh

IF diskcode THEN DiskReady = FALSE

END FUNCTION

