DEFINT A-Z

' $INCLUDE: 'PARM.INC'
' $INCLUDE: 'SAVEENV.INC'
' $INCLUDE: 'SETCURS.INC'
' $INCLUDE: 'TRUEFALS.INC'
' $INCLUDE: 'KEYCODE.INC'

DECLARE FUNCTION GetKey$ (parm())
DECLARE FUNCTION GKBusy (b)
DECLARE FUNCTION LastKey$ (k$)
DECLARE SUB ScreenSaver ()              'This is an example screen saver.
DECLARE SUB About (parm())              'This is an example hotkey proc.


'External functions:

DECLARE SUB InfoBox (msg$(), parm())    'Only used by About()

SUB About (parm())

REDIM temp(1 TO MAXPARM)                'For a call to InfoBox()
FOR x = MINPARM TO MAXPARM
     temp(x) = parm(x)
NEXT x
temp(3) = 2

REDIM msg$(1 TO 3)
msg$(1) = "HOMONLIB 2.0"
msg$(2) = " (c)1995 Raymond W. Marron "
msg$(3) = "HOMONCULOUS PROGRAMMING"

InfoBox msg$(), temp()

ERASE temp, msg$                        'Destroy temporary arrays.

END SUB

FUNCTION GetKey$ (parm())
'****************************************************************************
'Used to control user input.  It includes a screensaver routine and a way to
' trap hotkeys with polling rather than ON KEY.  Use it where you would
' normally place an INKEY$ loop.
'
'Chances are, you will want to modify this function for each program that you
' write.  See below for information about how the screensaver works and how
' to add hotkey procedures.  If you modify it, be sure to recompile the
' module and build a new LIB/QLB with a new name corresponding to your
' application.
'
'****************************************************************************

GOSUB SetIdle

DO

     'If it has been 5 minutes since a keypress, do the screensaver routine:

     IF TIMER > idle! THEN
          ScreenSaver
          GOSUB SetIdle                      'Reset the idle timer.
     END IF

     'Otherwise check the keyboard for activity:

     x$ = INKEY$
     pressed = LEN(x$)

     'If a key was pressed, see if it was a hotkey before returning it:

     IF pressed THEN
          IF NOT GKBusy(MAYBE) THEN
               x = GKBusy(TRUE)
               SELECT CASE KeyCode(x$)
                    CASE KCF12
                         About parm()
                         pressed = FALSE     'Don't want this key returned!
                    CASE ELSE
                         'Not a hotkey
               END SELECT
               x = GKBusy(FALSE)
          END IF
          GOSUB SetIdle                 'Reset the idle timer if a key was
     END IF                             'pressed.

LOOP UNTIL pressed

GetKey$ = x$                            'Return the value of the keypress.
x$ = LastKey$(x$)                       'Update LastKey$() with this value.

EXIT FUNCTION

SetIdle:
     idle! = TIMER + 300!               'Set to 5 minutes from now.
     RETURN

END FUNCTION

FUNCTION GKBusy (b) STATIC
'****************************************************************************
'This function is used only by GetKey$() and you should never call it outside
' of that function.  See the GetKey$() source for usage details.
'****************************************************************************

STATIC busy

GKBusy = busy                           'Return stored value.

IF b = TRUE OR b = FALSE THEN busy = b  'Change only if given TRUE or FALSE.

END FUNCTION

FUNCTION LastKey$ (k$) STATIC
'****************************************************************************
'When used in conjunction with GetKey$(), LastKey$() will return the value
' returned by the previous call to GetKey$().  One possible use would be to
' find out the key used to exit a previously called function (assuming that
' function used GetKey$() for all its input).
'
'To use the function, merely pass a null string as the argument.  This will
' return the stored value without changing it.  Should you wish to update
' LastKey$() with a value other than the one placed there by the last call to
' GetKey$(), just pass it a non-null string.
'
'****************************************************************************

STATIC last$

LastKey$ = last$                   'Retain previous value for return.

IF LEN(k$) THEN                    'If anything other than a null string is
     last$ = k$                    'passed, the value of LastKey$() will be
END IF                             'updated.

END FUNCTION

SUB ScreenSaver

DIM OldEnv AS EnvironType          'Save the current environment.
SaveEnv OldEnv

c = SetCursor(SCNONE)              'Turn the cursor off, clear the screen.
VIEW PRINT
COLOR 7, 0
CLS

blank$ = "          "              'Used to erase the time & date

DO                                 'Show the time & date on the screen
     row = INT(RND * 23) + 1       'in random colors and locations
     col = INT(RND * 70) + 1       'until a key is pressed.
     c = INT(RND * 7) + 9
     COLOR c
     LOCATE row, col + 1
     PRINT TIME$;
     c = INT(RND * 7) + 9
     COLOR c
     LOCATE row + 1, col
     PRINT DATE$;
     SLEEP 2
     LOCATE row, col
     PRINT blank$;
     LOCATE row + 1, col
     PRINT blank$;
LOOP UNTIL LEN(INKEY$)

RestEnv OldEnv                     'Restore the environment.

END SUB

