DEFINT A-Z

DECLARE FUNCTION KeyCode (k$)

FUNCTION KeyCode (k$) STATIC
'****************************************************************************
'KeyCode() returns an integer representing the ASCII code of the key passed.
' If k$ has a length of one, a positive integer will be returned.  If its
' length is two, a negative integer will be returned.
'
'Examples:     KeyCode("M")               -->   77
'              KeyCode(CHR$(0)+CHR$(59))  -->  -59  (Constant: KCF1)
'              KeyCode("")                -->   0
'
'Constants for common KeyCode() return values are defined in the KEYCODE.INC
' file.  These are much easier to remember and use than the actual numeric
' values.  The function declaration for KeyCode() is also included in this
' file.
'
'****************************************************************************

SELECT CASE LEN(k$)
     CASE 0                   'The ASC() function blows up on a null string.
          KeyCode = 0
     CASE 2
          KeyCode = -ASC(RIGHT$(k$, 1))
     CASE ELSE
          KeyCode = ASC(k$)
END SELECT

END FUNCTION

