'These constants represent some of the possible values returned by the
'KeyCode() function.  The great thing about constants is that no matter how
'many you define, no memory is used unless you actually reference them!

DECLARE FUNCTION KeyCode(k$)

CONST KCNULL        = 0                 'Null string

CONST KCBACKSPACE   = 8                 'Misc. keys
CONST KCTAB         = 9
CONST KCENTER       = 13
CONST KCESC         = 27
CONST KCSPACEBAR    = 32
CONST KCUP          = -72
CONST KCDOWN        = -80
CONST KCLEFT        = -75
CONST KCRIGHT       = -77
CONST KCPGUP        = -73
CONST KCPGDN        = -81
CONST KCINSERT      = -82
CONST KCDELETE      = -83
CONST KCHOME        = -71
CONST KCEND         = -79

CONST KCCTRLBACKSPACE  = 127            'Misc Shift/Ctrl/Alt-keys
CONST KCSHTAB       = -15
CONST KCCTRLENTER   = 10
CONST KCCTRLLEFT    = -115
CONST KCCTRLRIGHT   = -116
CONST KCCTRLPGUP    = -132
CONST KCCTRLPGDN    = -118
CONST KCCTRLHOME    = -119
CONST KCCTRLEND     = -117

CONST KCF1          = -59               'Plain Fn keys
CONST KCF2          = -60
CONST KCF3          = -61
CONST KCF4          = -62
CONST KCF5          = -63
CONST KCF6          = -64
CONST KCF7          = -65
CONST KCF8          = -66
CONST KCF9          = -67
CONST KCF10         = -68
CONST KCF11         = -133
CONST KCF12         = -134

CONST KCSHF1        = -84               'Shift-Fn keys
CONST KCSHF2        = -85
CONST KCSHF3        = -86
CONST KCSHF4        = -87
CONST KCSHF5        = -88
CONST KCSHF6        = -89
CONST KCSHF7        = -90
CONST KCSHF8        = -91
CONST KCSHF9        = -92
CONST KCSHF10       = -93
CONST KCSHF11       = -135
CONST KCSHF12       = -136

CONST KCCTRLF1      = -94               'Ctrl-Fn keys
CONST KCCTRLF2      = -95
CONST KCCTRLF3      = -96
CONST KCCTRLF4      = -97
CONST KCCTRLF5      = -98
CONST KCCTRLF6      = -99
CONST KCCTRLF7      = -100
CONST KCCTRLF8      = -101
CONST KCCTRLF9      = -102
CONST KCCTRLF10     = -103
CONST KCCTRLF11     = -137
CONST KCCTRLF12     = -138

CONST KCALTF1       = -104              'Alt-Fn keys
CONST KCALTF2       = -105
CONST KCALTF3       = -106
CONST KCALTF4       = -107
CONST KCALTF5       = -108
CONST KCALTF6       = -109
CONST KCALTF7       = -110
CONST KCALTF8       = -111
CONST KCALTF9       = -112
CONST KCALTF10      = -113
CONST KCALTF11      = -139
CONST KCALTF12      = -140

CONST KCCTRLA       = 1                 'Ctrl-Letter keys
CONST KCCTRLB       = 2
CONST KCCTRLC       = 3
CONST KCCTRLD       = 4
CONST KCCTRLE       = 5
CONST KCCTRLF       = 6
CONST KCCTRLG       = 7
CONST KCCTRLH       = 8
CONST KCCTRLI       = 9
CONST KCCTRLJ       = 10
CONST KCCTRLK       = 11
CONST KCCTRLL       = 12
CONST KCCTRLM       = 13
CONST KCCTRLN       = 14
CONST KCCTRLO       = 15
CONST KCCTRLP       = 16
CONST KCCTRLQ       = 17
CONST KCCTRLR       = 18
CONST KCCTRLS       = 19
CONST KCCTRLT       = 20
CONST KCCTRLU       = 21
CONST KCCTRLV       = 22
CONST KCCTRLW       = 23
CONST KCCTRLX       = 24
CONST KCCTRLY       = 25
CONST KCCTRLZ       = 26

CONST KCALTA        = -30               'Alt-Letter keys   
CONST KCALTB        = -48
CONST KCALTC        = -46
CONST KCALTD        = -32
CONST KCALTE        = -18
CONST KCALTF        = -33
CONST KCALTG        = -34
CONST KCALTH        = -35
CONST KCALTI        = -23
CONST KCALTJ        = -36
CONST KCALTK        = -37
CONST KCALTL        = -38
CONST KCALTM        = -50
CONST KCALTN        = -49
CONST KCALTO        = -24
CONST KCALTP        = -25
CONST KCALTQ        = -16
CONST KCALTR        = -19
CONST KCALTS        = -31
CONST KCALTT        = -20
CONST KCALTU        = -22
CONST KCALTV        = -47
CONST KCALTW        = -17
CONST KCALTX        = -45
CONST KCALTY        = -21
CONST KCALTZ        = -44

