DEFINT A-Z

DECLARE FUNCTION ParseDieL$ (die$)


'External procedures:

DECLARE FUNCTION LongDice& (n&, d&, a&)
DECLARE FUNCTION Lstr$ (l&)

FUNCTION ParseDieL$ (die$)
'****************************************************************************
'Works exactly like ParseDie$(), but expects long integers.  There is no
' overflow checking in ParseDieL$().
'****************************************************************************

IF LEN(RTRIM$(die$)) = 0 THEN                     'Blank?
     ParseDieL$ = "0"
     EXIT FUNCTION
END IF

x = INSTR(die$, "*")                              'Constant?
IF x THEN
     ParseDieL$ = MID$(die$, x + 1)
     EXIT FUNCTION
END IF

n$ = ""        'Separate the string into the Number of rolls,
d$ = ""        'the number of sides on the Die,
a$ = ""        'and the amount to Add to each roll.

nda = 1        'Keep track of which one we're currently building.

FOR x = 1 TO LEN(die$)
     x$ = MID$(die$, x, 1)
     SELECT CASE ASC(x$)
          CASE 48 TO 57                           '0-9
               IF nda = 1 THEN n$ = n$ + x$
               IF nda = 2 THEN d$ = d$ + x$
               IF nda = 3 THEN a$ = a$ + x$
          CASE 68, 100                            'd/D
               nda = 2
          CASE 43, 45                             '+/-
               nda = 3
               a$ = x$
          CASE 32                                 'space
               'Ignore it
          CASE ELSE                               'Invalid character. Return
               ParseDieL$ = "@" + Istr$(x)        'the location of the
               EXIT FUNCTION                      'offending character.
     END SELECT
NEXT x

IF LEN(n$) THEN n& = VAL(n$) ELSE n& = 1&         'Default to 1d4+0
IF LEN(d$) THEN d& = VAL(d$) ELSE d& = 4&
IF LEN(a$) THEN a& = VAL(a$) ELSE a& = 0&

ParseDieL$ = Lstr$(LongDice&(n&, d&, a&))         'Get the value.

END FUNCTION

