DEFINT A-Z

DECLARE FUNCTION Replace$ (orig$, old$, new$)


'External procedures:

DECLARE FUNCTION Stuff$ (o$, p, d, c$)

FUNCTION Replace$ (orig$, old$, new$)
'****************************************************************************
'Replace$() does just what it says - it replaces all occurrences of one
' substring with another string.
'
'If the new$ argument is a null string, Replace$() effectively removes all
' occurrences of the substring and works exactly like Squeeze$().
'
'See also: Stuff$(), Squeeze$()
'
'****************************************************************************

Replace$ = orig$

IF orig$ = "" OR old$ = "" THEN EXIT FUNCTION     'Can't replace nulls!

x$ = orig$                                        'Use a temp variable.

d = LEN(old$)            'The length of the substring we are replacing.
l = LEN(new$)            'The length of the replacement string.  If non-zero,
IF l THEN l = l - 1      'subtract one here rather than within the loop.

i = INSTR(x$, old$)      'Find the first occurrence of the substring.

DO WHILE i > 0           'Go through the string until it no longer appears.

     x$ = Stuff$(x$, i, d, new$)        'Replace this occurrence.

     i = INSTR(i + l, x$, old$)         'Find the next occurrence.

LOOP

Replace$ = x$            'Return the new string.

END FUNCTION

