DEFINT A-Z

' $INCLUDE: 'SAVEENV.INC'
' $INCLUDE: 'SETCURS.INC'

'(SUBs are declared in the include file)


'External procedures:

DECLARE SUB RestScreen (f$)
DECLARE SUB SaveScreen (f$)
DECLARE SUB GetColor (fg, bg)
DECLARE SUB SetColor (fg, bg)
DECLARE SUB GetView (top, bot)
DECLARE SUB SetView (top, bot)
DECLARE FUNCTION TempName$ (p$)
DECLARE FUNCTION VPage (p)

SUB RestEnv (e AS EnvironType)
'****************************************************************************
'Restores an environment that was previously saved by SaveEnv().
'See SaveEnv() for details.
'****************************************************************************

x = 0
IF e.savepage = x THEN
     sf$ = e.savefile
     RestScreen sf$
     KILL sf$
ELSE
     PCOPY e.savepage, x
     x = VPage(e.savepage)
END IF
SetView e.vptop, e.vpbot
x = SetCursor(e.curs)
LOCATE e.row, e.col
SetColor e.fg, e.bg

END SUB

SUB SaveEnv (e AS EnvironType)
'****************************************************************************
'Used to save all relevant environment information prior to changing the
' screen.  Pass an EnvironType variable (as defined in SAVEENV.INC) to be
' filled with this information.
'
'In order for this function to work correctly, you must use the set/get
' functions provided in the library prior to calling this function.  For
' example, if you directly changed the screen colors with the COLOR statement
' rather than SetColor(), the colors that get saved and restored by SaveEnv()
' would be undefined and probably wrong.  The same holds true for SetCursor()
' and SetView().
'
'The temporary files used if SaveScreen() needs to be called are stored in
' the current directory.  Make sure you are in the same directory when
' restoring.  This should not be a problem because if you are using these
' functions, you are already practicing modular programming and will leave
' the current path as you found it.
'
'Example usage:     ' $INCLUDE: 'SAVEENV.INC'
'                   DIM PrevEnv AS EnvironType
'                   SaveEnv PrevEnv
'                   '...
'                   'Mess with the environment here...
'                   '...
'                   RestEnv PrevEnv
'
'See also: SetColor(), SetView(), SetCursor()
'
'****************************************************************************

e.curs = SetCursor(SCINQUIRY)
e.row = CSRLIN
e.col = POS(0)
GetColor x, y                           'TYPE elements can't be passed by
e.fg = x                                'reference, so we have to use x & y.
e.bg = y
GetView x, y
e.vptop = x
e.vpbot = y
e.savepage = VPage(0)
IF e.savepage = 0 THEN
     sf$ = TempName$("")                'SaveScreen() expects a variable
     e.savefile = sf$                   'length string, so we use sf$.
     SaveScreen sf$
ELSE
     PCOPY 0, e.savepage
END IF

END SUB

