DEFINT A-Z

DECLARE SUB SaveScreen (filename$)
DECLARE SUB RestScreen (filename$)

SUB RestScreen (filename$)
'****************************************************************************
'Restores a screen saved by SaveScreen().
'
'You should only pass a filename that you know contains data created by the
' SaveScreen() sub.  I have no idea what would happen if you used any other
' kind of data.  Use at your own risk.  If you pass a filename that does not
' exist, a run-time error will occur.
'
'See also: SaveEnv()
'
'****************************************************************************

vs& = PEEK(&H63) + PEEK(&H64) * 256     'Get CRT controller port

IF vs& = &H3B4 THEN
     vs& = &HB000                       'Video RAM segment address (mono)
ELSE
     vs& = &HB800                       'Video RAM segment address (color)
END IF

DEF SEG = vs&
BLOAD filename$, 0
DEF SEG

END SUB

SUB SaveScreen (filename$)
'****************************************************************************
'Saves the current text screen to the specified binary file.  If the file
' already exists, it will be overwritten.
'
'This function was only tested in text mode (SCREEN 0).  I have no idea what
' it would do in any other screen mode.  Use at your own risk.
'
'See also: RestScreen(), SaveEnv()
'
'****************************************************************************

vs& = PEEK(&H63) + PEEK(&H64) * 256     'Get CRT controller port

IF vs& = &H3B4 THEN
     vs& = &HB000                       'Video RAM segment address (mono)
ELSE
     vs& = &HB800                       'Video RAM segment address (color)
END IF

DEF SEG = vs&
BSAVE filename$, 0, 4000
DEF SEG

END SUB

