DEFINT A-Z

DECLARE FUNCTION SetBG (bg)
DECLARE FUNCTION SetFG (fg)

FUNCTION SetBG (bg) STATIC
'****************************************************************************
'SetBG() is a set-get function for the background color.  If a negative
' number is passed, the current value will be returned without changing it.
'
'See also: SetFG(), SaveEnv()
'
'****************************************************************************

SetBG = oldbg                      'Return the currently stored value.

IF bg >= 0 THEN                    'If not inquiry only, change the current
     COLOR , bg                    'background color to the new value and
     oldbg = bg                    'store this value for subsequent calls.
END IF

END FUNCTION

FUNCTION SetFG (fg) STATIC
'****************************************************************************
'SetFG() is a set-get function for the foreground color.  If a negative
' number is passed, the current value will be returned without changing it.

'See also: SetBG(), SaveEnv()
'
'****************************************************************************

SetFG = oldfg                      'Return the currently stored value.

IF fg >= 0 THEN                    'If not inquiry only, change the current
     COLOR fg                      'foreground color to the new value and
     oldfg = fg                    'store this value for subsequent calls.
END IF

END FUNCTION

