DEFINT A-Z

DECLARE SUB SetView (top, bot)
DECLARE SUB GetView (top, bot)

SUB GetView (top, bot)
'****************************************************************************
'GetView() is used to retrieve the current VIEW PRINT settings that were
' previously set with SetView().  The top and bot arguments will be updated
' with these values.
'****************************************************************************

top = -1                 'By sending negative numbers to SetView(), we are
bot = -1                 'asking it to update the passed parameters with the
                         'stored values and not change anything.
SetView top, bot

END SUB

SUB SetView (top, bot) STATIC
'****************************************************************************
'SetView() is used to set the current viewport (VIEW PRINT) settings and
' allow them to be retrieved by GetView().  Use it as you would the VIEW
' PRINT statement:
'
'                   SetView 4, 24  =  VIEW PRINT 4 TO 24
'                   SetView 0, 0   =  VIEW PRINT
'
'The top and bot arguments must both be equal to zero or both be greater than
' zero.  If one argument is zero and the other is not, nothing will change.
'
'****************************************************************************

IF top = zero AND bot = zero THEN       'When both values are zero, it means
     st = zero                          'to reset the viewport to the entire
     sb = zero                          'screen.
     VIEW PRINT
ELSEIF top > zero AND bot > zero THEN   'If both values are positive, it
     st = top                           'means to update the viewport to the
     sb = bot                           'new values
     VIEW PRINT top TO bot
ELSEIF top < zero AND bot < zero THEN   'If both values are negative, this
     top = st                           'must be a call from GetView() asking
     bot = sb                           'for the currently stored values.
END IF

END SUB

