DEFINT A-Z

' $INCLUDE: 'KEYCODE.INC'
' $INCLUDE: 'PARM.INC'
' $INCLUDE: 'SAVEENV.INC'
' $INCLUDE: 'SETCURS.INC'
' $INCLUDE: 'TAGGING.INC'

DECLARE FUNCTION TagBox (title$, choice$(), tag(), parm())

'External procedures:

DECLARE SUB Box (t, l, b, r, b$)
DECLARE SUB BoxCalc (t, l, b, r, tall, wide)
DECLARE FUNCTION GetKey$ (parm())
DECLARE FUNCTION PadR$ (t$, l)
DECLARE FUNCTION PadX$ (t$, l, s, c$)
DECLARE FUNCTION Istr$ (i)
DECLARE FUNCTION VPage (p)

FUNCTION TagBox (title$, choice$(), tag(), parm())
'****************************************************************************
'TagBox() is to ListBox() what PickSome() is to PickOne().  It returns the
' element number of the item selected, or LBOUND(choice$)-1 if the user
' pressed ESC.  There are no hotkeys in TagBox() except for the tagging keys.
'
'See ListBox() for general information, PickSome() for information on the
' tagging keys.
'
'    parm(1) = top row  0=Center
'    parm(2) = left column  0=Center
'    parm(3) = box border type 1-4.  See SUB Panes() for numeric boxtypes.
'    parm(4) = initial selected choice
'    parm(5) = minimum choice$() element to use
'    parm(6) = maximum choice$() element to use
'    parm(7) = allow letter keys?  0=No  <0=Instant select  >0=Alpha Search
'    parm(8) = tagging key  Default=KCSPACEBAR
'    parm(9) = tag all key  Default=KCF6
'    parm(10) = tag none key  Default=KCF7
'    parm(11) = toggle tags key  Default=KCF8
'
'****************************************************************************

'                     *** Preliminary calculations ***

IF parm(5) OR parm(6) THEN              'Get information about choice$().
     min = parm(5)
     max = parm(6)
ELSE
     min = LBOUND(choice$)
     max = UBOUND(choice$)
END IF

wide = LEN(title$)                      'Find out how wide & tall to make the
FOR x = min TO max                      'box
     tall = tall + 1
     l = LEN(choice$(x))
     IF l > wide THEN wide = l
NEXT x
IF tall > 10 THEN tall = 10
wide = wide + 2                         'Allow for the frame/tag identifier.

row1 = parm(1)                          'Find out where to place the box.
col1 = parm(2)
BoxCalc row1, col1, row2, col2, tall, wide

IF parm(7) < 0 THEN                     'Set up the letter keys if wanted.
     FOR x = min TO max
          c$ = UCASE$(LTRIM$(RTRIM$(choice$(x))))
          l = 1
          DO
               l$ = MID$(c$, l, 1)
               l = l + 1
          LOOP UNTIL INSTR(ltrs$, l$) = 0 OR l > LEN(c$)
          ltrs$ = ltrs$ + l$
     NEXT x
END IF
                                        'Set up the tagging keys:
kTag = parm(8)
IF kTag = 0 THEN kTag = KCSPACEBAR           'Default = spacebar
IF kTag = -1 THEN kTag = 9999                'Disabled?
kAll = parm(9)
IF kAll = 0 THEN kAll = KCF6                 'Default = F6
IF kAll = -1 THEN kAll = 9998
kNone = parm(10)
IF kNone = 0 THEN kNone = KCF7               'Default = F7
IF kNone = -1 THEN kNone = 9997
kToggle = parm(11)
IF kToggle = 0 THEN kToggle = KCF8           'Default = F8
IF kToggle = -1 THEN kToggle = 9996

REDIM t$(DISABLED TO TAGGED)            'Set up the tagging identifiers
t$(DISABLED) = " "
t$(UNTAGGED) = " "
t$(TAGGED) = CHR$(251)                       'A check-mark


'                          *** Draw the Box ***

DIM OldEnv AS EnvironType               'Save/Change the environment.
SaveEnv OldEnv
x = SetCursor(SCNONE)                   'Turn off the cursor

workpage = VPage(0)                     'Allocate a non-critical video page.
PCOPY 0, workpage                       'Copy the screen to the scratch page.
SCREEN , , workpage, 0                  'Draw on the work page until ready.

COLOR parm(FGWB), parm(BGWB)            'Draw the outline & title
Box row1, col1, row2, col2, Istr$(parm(3))
SELECT CASE parm(3)
     CASE 2
          lc$ = CHR$(181)
          rc$ = CHR$(198)
          h$ = CHR$(205)
          v$ = CHR$(186)
     CASE 3
          lc$ = CHR$(181)
          rc$ = CHR$(198)
          h$ = CHR$(205)
          v$ = CHR$(179)
     CASE 4
          lc$ = CHR$(180)
          rc$ = CHR$(195)
          h$ = CHR$(198)
          v$ = CHR$(186)
     CASE ELSE
          lc$ = CHR$(180)
          rc$ = CHR$(195)
          h$ = CHR$(198)
          v$ = CHR$(179)
END SELECT
IF LEN(title$) THEN
     x = wide - (LEN(title$) + 2)
     LOCATE row1, col1 + (x \ 2) + 1
     PRINT lc$; title$; rc$;
END IF

COLOR 0, 0                              'Print the shadow
l = col2 + 1
FOR x = (row1 + 1) TO row2
     LOCATE x, l: PRINT " "
NEXT x
LOCATE row2 + 1, col1 + 1: PRINT SPACE$(wide + 2);

PCOPY workpage, 0                       'Pop the box onto the screen.
SCREEN , , 0, 0                         'Draw on screen 0 again.
x = VPage(workpage)                     'Release the scratch video page.

'                    *** Pick a choice, any choice! ***

sel = parm(4)                           'Initially position the list.
IF sel < min OR sel > max THEN sel = min
top = min
bot = top + tall - 1
DO WHILE bot < sel
     top = top + 1
     bot = bot + 1
LOOP
col = col1 + 1

id$ = CHR$(18)                          'The little indicator character.
irow = row1 + 1

COLOR parm(FGWT), parm(BGWT)

DO                                      'The main loop!
    
     row = row1                         'Print the choices.
     FOR x = top TO bot
          row = row + 1
          IF x = sel THEN COLOR parm(FGWS), parm(BGWS)
          LOCATE row, col
          PRINT PadR$(choice$(x), wide - 1) + t$(tag(x))
          COLOR parm(FGWT), parm(BGWT)
     NEXT x

     IF tall = 10 THEN                  'Put an indicator on the side.
          COLOR parm(FGWB), parm(BGWB)
          LOCATE irow, col2
          PRINT v$;
          x = INT((sel / max) * 10)
          IF x < 1 THEN x = 1
          irow = row1 + x
          LOCATE irow, col2
          PRINT id$;
          COLOR parm(FGWT), parm(BGWT)
     END IF

     IF parm(7) > 0 THEN                'Show the search string on the bottom
          COLOR parm(FGWB), parm(BGWB)
          LOCATE row2, col1 + 1
          PRINT PadX$(search$, wide, 0, h$);
          COLOR parm(FGWT), parm(BGWT)
     END IF

     k$ = UCASE$(GetKey$(parm()))            'Get keyboard input
     k = KeyCode(k$)

     SELECT CASE k
          CASE KCESC                         'ESC
               sel = min - 1
               EXIT DO
          CASE KCENTER                       'Enter
               EXIT DO
          CASE KCUP                          'Up arrow
               sel = sel - 1
               IF sel < min THEN sel = min
               IF sel < top THEN
                    top = top - 1
                    bot = bot - 1
               END IF
          CASE KCDOWN                        'Down arrow
               sel = sel + 1
               IF sel > max THEN sel = max
               IF sel > bot THEN
                    top = top + 1
                    bot = bot + 1
               END IF
          CASE KCPGUP                        'PgUp
               IF top > min THEN
                    top = top - tall
                    bot = bot - tall
                    IF top < min THEN
                         top = min
                         bot = top + tall - 1
                    END IF
                    IF sel > bot THEN sel = bot
               END IF
          CASE KCPGDN                        'PgDn
               IF bot < max THEN
                    top = top + tall
                    bot = bot + tall
                    IF bot > max THEN
                         bot = max
                         top = bot - tall + 1
                    END IF
                    IF sel < top THEN sel = top
               END IF
          CASE KCHOME                        'Home
               sel = min
               top = min
               bot = top + tall - 1
          CASE KCEND                         'End
               sel = max
               bot = max
               top = bot - tall + 1
          CASE kTag                                         'Tag/Untag
               IF tag(sel) <> DISABLED THEN
                    tag(sel) = tag(sel) + 1
                    IF tag(sel) > TAGGED THEN tag(sel) = UNTAGGED
                    IF sel < max THEN sel = sel + 1
               END IF
          CASE kAll                                         'Tag All
               FOR x = min TO max
                    IF tag(x) <> DISABLED THEN
                         tag(x) = TAGGED
                    END IF
               NEXT x
          CASE kNone                                        'Tag None
               FOR x = min TO max
                    IF tag(x) <> DISABLED THEN
                         tag(x) = UNTAGGED
                    END IF
               NEXT x
          CASE kToggle                                      'Toggle Tags
               FOR x = min TO max
                    IF tag(x) <> DISABLED THEN
                         tag(x) = tag(x) + 1
                         IF tag(x) > TAGGED THEN tag(x) = UNTAGGED
                    END IF
               NEXT x
          CASE KCBACKSPACE
               l = LEN(search$)
               IF l THEN search$ = LEFT$(search$, l - 1)
          CASE 32 TO 126
               IF parm(7) < 0 THEN                          'Instant select?
                    l = INSTR(ltrs$, k$)
                    IF l THEN
                         sel = min + l - 1
                         EXIT DO
                    END IF
               ELSEIF parm(7) > 0 THEN                      'Alpha search
                    l = LEN(search$)
                    IF l <= wide - 2 THEN
                         search$ = search$ + k$
                         l = l + 1
                    END IF
                    found = min - 1
                    FOR x = sel TO max
                         IF LEFT$(UCASE$(choice$(x)), l) = search$ THEN
                              found = x
                              EXIT FOR
                         END IF
                    NEXT x
                    IF found < min THEN
                         FOR x = min TO sel - 1
                              IF LEFT$(UCASE$(choice$(x)), l) = search$ THEN
                                   found = x
                                   EXIT FOR
                              END IF
                         NEXT x
                    END IF
                    IF found >= min THEN
                         sel = found
                         IF sel < top OR sel > bot THEN
                              top = min
                              bot = top + tall - 1
                         END IF
                         DO WHILE sel > bot
                              top = top + tall
                              bot = top + tall - 1
                         LOOP
                         IF bot > max THEN
                              bot = max
                              top = bot - tall + 1
                         END IF
                    END IF
               END IF
          CASE ELSE
               'Do nothing
     END SELECT

     IF k <> KCBACKSPACE AND (k < 32 OR k > 126) THEN search$ = ""

LOOP

'                     *** Clean up after ourselves ***

ERASE t$

RestEnv OldEnv

TagBox = sel                            'Return highlighted element

END FUNCTION

