DEFINT A-Z

' $INCLUDE: 'FILEPART.INC'
' $INCLUDE: 'TRUEFALS.INC'
' $INCLUDE: 'VALIDNAM.INC'

'(Function declaration in include file)


'External functions:

DECLARE FUNCTION DirExist (d$)
DECLARE FUNCTION DiskReady (d$)
DECLARE FUNCTION FileExist (f$)

FUNCTION ValidName (filename$)
'****************************************************************************
'Used to edit user input of filenames.  The filename can include an extended
' path as well as the filename itself.  The return value of the function will
' be one of the following constants defined in VALIDNAM.INC:
'
' Value   Constant     Description
'  -1     VNEXISTS     File exists.
'   0     VNVALID      Filename is valid, but does not exist.
'   1     VNDRIVE      Drive not ready.
'   2     VNPATH       Invalid path or path does not exist.
'   3     VNFILENAME   Invalid characters or length in filename.
'
'If a null string is passed the function will return VNFILENAME.
'
'****************************************************************************

f$ = UCASE$(filename$)

IF LEN(f$) = 0 THEN                               'Check for zero length.
     ValidName = VNFILENAME
     EXIT FUNCTION
END IF

IF NOT DiskReady(FileParts$(f$, FPDRIVE)) THEN    'Make sure the drive is
     ValidName = VNDRIVE                          'ready (if specified).
     EXIT FUNCTION
END IF

IF FileExist(f$) THEN                             'See if the file exists.
     ValidName = VNEXISTS
     EXIT FUNCTION
END IF

IF NOT DirExist(FileParts$(f$, FPPATH)) THEN      'See if the path is valid
     ValidName = VNPATH                           'or exists if specified.
     EXIT FUNCTION
END IF

n$ = FileParts$(f$, FPNAMEONLY)

IF LEN(n$) > 8 THEN                               'Check length of filename.
     ValidName = VNFILENAME
     EXIT FUNCTION
END IF

allowed$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_^$~!#%&-{}@`'()"

GOSUB CheckContents

n$ = FileParts$(f$, FPEXTENSION)

IF LEN(n$) > 3 THEN                               'Check length of extension.
     ValidName = VNFILENAME
     EXIT FUNCTION
END IF

GOSUB CheckContents

EXIT FUNCTION


CheckContents:

     'See if there are any invalid characters in the filename or extension

     FOR x = 1 TO LEN(n$)
          IF INSTR(allowed$, MID$(n$, x, 1)) = 0 THEN
               ValidName = VNFILENAME
               EXIT FUNCTION
          END IF
     NEXT x

RETURN


END FUNCTION

